var cqrCoUnitProto = function(){
    //Actually this name is reduced form of "Context Unit"
    //but also it's to the name of my girlfriend's 
    //favorit plush pet - Ko.. well.. Just to note. ;)
    this.id = '';
    this.parent = '';
    this.preResult = '';
    this.result = '';
    this.postResult = '';
    this.testResult = '';
    this.tuneupRequired = false;
    this.isSuccess = true;
    this.templateVarPattern = null;
    
    this.init = function(){
        //Shadow912: patch for {MozParam:XXX} of MozSearch format
        //Shadow912: patch for OpenSearch 1.1 compatible
        //this.templateVarPattern = new RegExp("((\\[:)|{)"+this.id+"(:)*?([\\d\\w]*)*?[\\]}]", "ig");
        ////cqrvars[4] -> cqrvars[2]
        //this.templateVarPattern = new RegExp("(\\[:|{)"+this.id+":*?(([\\d\\w-]+:?)*?)[\\]}]", "ig");
        this.templateVarPattern = new RegExp("((\\[:)|{)"+this.id+"(:)*?(([\\d\\w-]+:?)*?)(\\?)??[\\]}]", "ig");
        //EOf patch
        cqrLog.debug('"' + this.parent+':'+this.id+'" context unit plugged in.');
    };

    this.test = function Test(str){
        try{
            return this.templateVarPattern.test(str);
        }catch(err){
            cqrLog.err('Critical error in ' + this.parent + ':' + this.id + ' wrapper!', err);
            return false;
        }
    };

    //preprocessor wrapper    
    this.preprocess = function Preprocessor(event){
        try{
            this.preResult = this.preprocessor(event);
        }catch(err){
            cqrLog.err('Critical error in ' + this.parent + ':' + this.id + ' wrapper!', err);
            this.preResult = err;
        }
    };
    
    //processor wrapper
    this.process = function Processor(sourceString, outPlugObj, inputObject){
        try{
            this.tuneupRequired = false;
            this.templateVarPattern.lastIndex = 0;
            if (!this.templateVarPattern.test(sourceString)) return sourceString;
            this.templateVarPattern.lastIndex = 0;
            if (inputObject) inputObject.isEditable = true;
            
            var ret = this.processor(sourceString,  this.templateVarPattern, outPlugObj, inputObject);
            this.templateVarPattern.lastIndex = 0;
            return ret;
        }catch(err){
            cqrLog.err('Critical error in ' + this.id + ' wrapper!', err);
            return sourceString;
        }
    };
    
    //postprocessor wrapper
    this.postprocess = function Postprocessor(event){
        try{
            //not implemented
            this.postResult = this.postprocessor(event);
        }catch(err){
            cqrLog.err('Critical error in ' + this.id + ' wrapper!', err);
            this.postResult = '';
        }
    };
    
    this.tester = function(str){
        return this.VariableRegexp.test(str);
    };
    this.preprocessor = function(event){
        return '';
    };
    this.processor = function(Str, VariableRegexp, PluginObject){
        var retStr = Str.replace(VariableRegexp, this.preResult);
        return retStr;
    };
    this.postprocessorWrapper = function(event){
        //not implemented
        return null;
    };
}

var cqrGeneralCoUnitsHolder = function(){
    //Default "selection" contextual query unit
    this.selection = new cqrCoUnitProto();
    this.selection.id = 'selection';
    this.selection.parent = 'General';
    this.selection.templateVariable = 'selection';
    this.selection.preprocessor = function(event){
        var focusedWindow = document.commandDispatcher.focusedWindow;
        var pageselection = "";
        //Thanks to Yuriy for textbox & textarea selection extraction
        var node = event.explicitOriginalTarget;
        if ((node) && 
            ((node.nodeName.toUpperCase() == "TEXTAREA") ||
            (node.nodeName.toUpperCase() == "INPUT" && node.type == "text"))) {
            pageselection = node.value.substring(node.selectionStart, node.selectionEnd);
        }else{
            //new way to get selection using Native Wrappers. Can be incompatible with older versions of Firefox
            var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
            pageselection = String(winWrapper.getSelection());
        }
        return pageselection;
    };
    this.selection.processor = function(str, reVar, pluginObj){
        var retStr = str.replace(reVar, this.preResult);
        //Shadow912: patch for {searchTerms} with option strings
        //if (retStr == "") this.tuneupRequired = true;
        if (this.preResult == "") this.tuneupRequired = true;
        //Eof patch
        return retStr;
    }
    this.selection.init();

    //Default "searchTerms" contextual query unit
    //the same as "selection"
    this.searchterms = new cqrCoUnitProto();
    this.searchterms.id = 'searchterms';
    this.searchterms.parent = 'General';
    this.searchterms.templateVariable = 'searchterms';
    this.searchterms.preprocessor = function(event){
        var focusedWindow = document.commandDispatcher.focusedWindow;
        var pageselection = "";
        //Thanks to Yuriy for textbox & textarea selection extraction
        var node = event.explicitOriginalTarget;
        if ((node) && 
            ((node.nodeName.toUpperCase() == "TEXTAREA") ||
            (node.nodeName.toUpperCase() == "INPUT" && node.type == "text"))) {
            pageselection = node.value.substring(node.selectionStart, node.selectionEnd);
        }else{
            //new way to get selection using Native Wrappers. Can be incompatible with older versions of Firefox
            var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
            pageselection = String(winWrapper.getSelection());
        }
        return pageselection;
    };
    this.searchterms.processor = function(str, reVar, pluginObj){
        var retStr = str.replace(reVar, this.preResult);
        //Shadow912: patch for {searchTerms} with option strings
        //if (retStr == "") this.tuneupRequired = true;
        if (this.preResult == "") this.tuneupRequired = true;
        //Eof patch
        return retStr;
    }
    this.searchterms.init();

    //Default "text" contextual query unit
    this.text = new cqrCoUnitProto();
    this.text.id = 'text';
    this.text.parent = 'General';
    this.text.templateVariable = 'text';
    this.text.processor = function(str, reVar, pluginObj){
        var retStr = str.replace(reVar, '');
        return retStr;
    }
    this.text.init();

    //Default "prompt" contextual query unit
    this.prompt = new cqrCoUnitProto();
    this.prompt.id = 'prompt';
    this.prompt.parent = 'General';
    this.prompt.templateVariable = 'prompt';
    this.prompt.processor = function(str, reVar, pluginObj){
        this.tuneupRequired = true;
        var retStr = str.replace(reVar, '');
        return retStr;
    }
    this.prompt.init();

    //Default page "url" contextual query unit
    this.url = new cqrCoUnitProto();
    this.url.id = 'url';
    this.url.parent = 'General';
    this.url.templateVariable = 'url';
    this.url.preprocessor = function(event){
        try{
            var focusedWindow = document.commandDispatcher.focusedWindow;
            var url = decodeURIComponent(focusedWindow.location.href);
        }catch(er){url=""}
        return url;
    };
    this.url.init();

    //Default "host" contextual query unit
    this.host = new cqrCoUnitProto();
    this.host.id = 'host';
    this.host.parent = 'General';
    this.host.templateVariable = 'host';
    this.host.preprocessor = function(event){
        try {
            var focusedWindow = document.commandDispatcher.focusedWindow;
            var host = focusedWindow.location.host;
        }catch(er){host=""}
        return host;
    };
    this.host.init();

    //Default "title" contextual query unit
    this.title = new cqrCoUnitProto();
    this.title.id = 'title';
    this.title.parent = 'General';
    this.title.templateVariable = 'title';
    this.title.preprocessor = function(event){
        var focusedWindow = document.commandDispatcher.focusedWindow;
        var title = focusedWindow.document.title;
        return title;
    };
    this.title.init();

    //Default "source" contextual query unit
    this.source = new cqrCoUnitProto();
    this.source.id = 'source';
    this.source.parent = 'General';
    this.source.templateVariable = 'source';
    this.source.preprocessor = function(event){
        var focusedWindow = document.commandDispatcher.focusedWindow;
        var source = focusedWindow.document.documentElement.innerHTML;
        if (!source) source = '';
        return source;
    };
    this.source.init();

    //Default "linkurl" contextual query unit
    this.linkurl = new cqrCoUnitProto();
    this.linkurl.id = 'linkurl';
    this.linkurl.parent = 'General';
    this.linkurl.templateVariable = 'linkurl';
    this.linkurl.preprocessor = function(event){
        var linkURL = cqrFindParentNode(event.originalTarget, "a");
        if (linkURL) linkURL = decodeURIComponent(linkURL);
        var areaObj = cqrFindParentNode(event.originalTarget, "area");
        if (areaObj) linkURL = cqrAreaObj.href;
        return linkURL;
    };
    this.linkurl.init();

    //Default "imgurl" contextual query unit
    this.imgurl = new cqrCoUnitProto();
    this.imgurl.id = 'imgurl';
    this.imgurl.parent = 'General';
    this.imgurl.templateVariable = 'imgurl';
    this.imgurl.preprocessor = function(event){
        var imgURL = "";
        var imgObj = cqrFindParentNode(event.originalTarget, "img");
        if (imgObj) imgURL = decodeURIComponent(cqrAbsURI(imgObj.baseURI, imgObj.src));
        return imgURL;
    };
    this.imgurl.init();

    //Default "imgname" contextual query unit
    this.imgname = new cqrCoUnitProto();
    this.imgname.id = 'imgname';
    this.imgname.parent = 'General';
    this.imgname.templateVariable = 'imgname';
    this.imgname.preprocessor = function(event){
        var imgName = "";
        var imgObj = cqrFindParentNode(event.originalTarget, "img");
        if (imgObj){
            var imgURL = decodeURIComponent(cqrAbsURI(imgObj.baseURI, imgObj.src));
            imgName = getFNameFromURI(imgURL);
        }
        return imgName;
    };
    this.imgname.init();

    //Default "cliptext" contextual query unit
    this.cliptext = new cqrCoUnitProto();
    this.cliptext.id = 'cliptext';
    this.cliptext.parent = 'General';
    this.cliptext.templateVariable = 'cliptext';
    this.cliptext.preprocessor = function(event){
        var cliptext = cqrGetClipboardText() || ""
        return cliptext;
    };
    this.cliptext.init();

    //Default "matched:n" contextual query unit
    this.matched = new cqrCoUnitProto();
    this.matched.id = 'matched';
    this.matched.parent = 'General';
    this.matched.templateVariable = 'matched';
    this.matched.preprocessor = function(event){};
    this.matched.processor = function(str, reVar, pluginObj){
        var retstr = "";
        //reVar.lastIndex = 0;
        var cqrvars = reVar.exec(str);
        var lastind = 0;
        if (cqrvars){
            while (cqrvars){
                var tmpstr = str.substring(lastind, reVar.lastIndex);
                var matchnum = Number(cqrvars[4]);
                if (isNaN(matchnum)) matchnum = 0;
                if (pluginObj.lastmatch[matchnum]){
                    retstr += tmpstr.replace(cqrvars[0], pluginObj.lastmatch[matchnum]);
                }else{
                    retstr += tmpstr.replace(cqrvars[0], "");
                }
                lastind = reVar.lastIndex;
                cqrvars = reVar.exec(str);
            }
            retstr += str.substring(lastind);
        } else {retstr = str}
        return retstr;
    };
    this.matched.init();

    //Shadow912: patch for {moz:XXX} of MozSearch format
    //Original code from components/nsSearchService.js
    //Default "moz:XXX" contextual query unit
    this.moz = new cqrCoUnitProto();
    this.moz.id = 'moz';
    this.moz.parent = 'General';
    this.moz.templateVariable = 'moz';
    this.moz.preprocessor = function(event){};
    this.moz.processor = function(str, reVar, pluginObj, inputObj){
        const Ci = Components.interfaces;
        const Cc = Components.classes;
        const MOZ_OFFICIAL = "official";
        const MOZ_DISTRIBUTION_ID = "org.mozilla";
        const BROWSER_SEARCH_PREF = "browser.search.";
        var retstr = "";
        //reVar.lastIndex = 0;
        var cqrvars = reVar.exec(str);
        var lastind = 0;
        if (cqrvars){
            while (cqrvars){
                var tmpstr = str.substring(lastind, reVar.lastIndex);
                var matchstr = cqrvars[0]; //{moz:XXX}
                var condstr = cqrvars[4]; //a part of XXX
                switch (condstr){
                case "distributionID":
                  var distributionID = MOZ_DISTRIBUTION_ID;
                  try {
                    var prefB = Cc["@mozilla.org/preferences-service;1"].
                                getService(Ci.nsIPrefBranch);
                    distributionID = prefB.getCharPref(BROWSER_SEARCH_PREF +
                                                       "distributionID");
                  }
                  catch (ex) {}
                  retstr += tmpstr.replace(matchstr, distributionID);
                  break;

                case "locale":
                  function getLocale() {
                    const localePref = "general.useragent.locale";
                    var locale = getLocalizedPref(localePref);
                    if (locale)
                      return locale;

                    // Not localized
                    var prefs = Cc["@mozilla.org/preferences-service;1"].
                      getService(Ci.nsIPrefBranch);
                    return prefs.getCharPref(localePref);
                  };
                  function getLocalizedPref(aPrefName, aDefault) {
                      var prefB = Cc["@mozilla.org/preferences-service;1"].
                        getService(Ci.nsIPrefBranch);
                      const nsIPLS = Ci.nsIPrefLocalizedString;
                      try {
                        return prefB.getComplexValue(aPrefName, nsIPLS).data;
                      } catch (ex) {}

                      return aDefault;
                  };
                  retstr += tmpstr.replace(matchstr, getLocale());
                  break;

                case "official":
                  retstr += tmpstr.replace(matchstr, MOZ_OFFICIAL);
                  break;

                default :
                  retstr += tmpstr;
                }
                lastind = reVar.lastIndex;
                cqrvars = reVar.exec(str);
            }
            retstr += str.substring(lastind);
        } else {retstr = str}
        if (inputObj) inputObj.isEditable = false; //this isn't editable
        return retstr;
    };
    this.moz.init();
    //EOf patch

    //Shadow912: patch for {MozParam:XXX} of MozSearch format
    //Original code from components/nsSearchService.js
    //Default "MozParam:XXX" contextual query unit
    //  XXX = COND:(TrueVal:FalseVal)|Pref
    //  COND = defaultEngine|pref
    this.mozparam = new cqrCoUnitProto();
    this.mozparam.id = 'mozparam';
    this.mozparam.parent = 'General';
    this.mozparam.templateVariable = 'mozparam';
    this.mozparam.preprocessor = function(event){};
    this.mozparam.processor = function(str, reVar, pluginObj, inputObj){
        const Ci = Components.interfaces;
        const Cc = Components.classes;
        const BROWSER_SEARCH_PREF = "browser.search.";
        var retstr = "";
        //reVar.lastIndex = 0;
        var cqrvars = reVar.exec(str);
        var lastind = 0;
        if (cqrvars){
            while (cqrvars){
                var tmpstr = str.substring(lastind, reVar.lastIndex);
                var matchstr = cqrvars[0]; //{MozParam:XXX}
                var condvars = cqrvars[4].split(":"); //splited part of XXX
                if (condvars.length < 1) return null;
                switch (condvars[0]){ //COND
                case "defaultEngine":
                  if (condvars.length < 3) return null;
                  const defPref = BROWSER_SEARCH_PREF + "defaultenginename";
                  var defaultPrefB = Cc["@mozilla.org/preferences-service;1"].
                                     getService(Ci.nsIPrefService).
                                     getDefaultBranch(null);
                  const nsIPLS = Ci.nsIPrefLocalizedString;
                  var defaultName;
                  try {
                    defaultName = defaultPrefB.
                                  getComplexValue(defPref, nsIPLS).data;
                  } catch (ex) {}

                  // If this engine was the default search engine,
                  // use the true value(trueValue or falseValue)
                  if (pluginObj.Title == defaultName)
                    retstr += tmpstr.replace(matchstr, condvars[1]);
                  else
                    retstr += tmpstr.replace(matchstr, condvars[2]);
                  break;

                case "pref":
                  if (condvars.length < 2) return null;
                  var value;
                  try {
                    var prefB = Cc["@mozilla.org/preferences-service;1"].
                                getService(Ci.nsIPrefBranch);
                    value = prefB.getCharPref(BROWSER_SEARCH_PREF + "param." +
                                              condvars[1]);
                    retstr += tmpstr.replace(matchstr, value);
                  } catch (e) { }
                  break;

                default :
                  retstr += tmpstr;
                }
                lastind = reVar.lastIndex;
                cqrvars = reVar.exec(str);
            }
            retstr += str.substring(lastind);
        } else {retstr = str}
        if (inputObj) inputObj.isEditable = false; //this isn't editable
        return retstr;
    };
    this.mozparam.init();
    //EOf patch

    //Shadow912: patch for OpenSearch 1.1 compatible
    //count parameter
    this.count = new cqrCoUnitProto();
    this.count.id = 'count';
    this.count.parent = 'General';
    this.count.templateVariable = 'count';
    this.count.preprocessor = function(event){};
    this.count.processor = function(str, reVar, pluginObj, inputObj){
      var retStr = str.replace(reVar, ""); //not specified, implimented
      if (inputObj) inputObj.isEditable = false; //this isn't editable
      return retStr;
    };
    this.count.init();
    //startIndex parameter
    this.startindex = new cqrCoUnitProto();
    this.startindex.id = 'startindex';
    this.startindex.parent = 'General';
    this.startindex.templateVariable = 'startindex';
    this.startindex.preprocessor = function(event){};
    this.startindex.processor = function(str, reVar, pluginObj, inputObj){
      var retStr = str.replace(reVar, pluginObj.indexOffset);
      if (inputObj) inputObj.isEditable = false; //this isn't editable
      return retStr;
    };
    this.startindex.init();
    //startPage parameter
    this.startpage = new cqrCoUnitProto();
    this.startpage.id = 'startpage';
    this.startpage.parent = 'General';
    this.startpage.templateVariable = 'startpage';
    this.startpage.preprocessor = function(event){};
    this.startpage.processor = function(str, reVar, pluginObj, inputObj){
      var retStr = str.replace(reVar, pluginObj.pageOffset);
      if (inputObj) inputObj.isEditable = false; //this isn't editable
      return retStr;
    };
    this.startpage.init();
    //language parameter
    this.language = new cqrCoUnitProto();
    this.language.id = 'language';
    this.language.parent = 'General';
    this.language.templateVariable = 'language';
    this.language.preprocessor = function(event){};
    this.language.processor = function(str, reVar, pluginObj, inputObj){
      var retStr = str.replace(reVar, pluginObj.lang);
      if (inputObj) inputObj.isEditable = false; //this isn't editable
      return retStr;
    };
    this.language.init();
    //inputEncoding parameter
    this.inputencoding = new cqrCoUnitProto();
    this.inputencoding.id = 'inputencoding';
    this.inputencoding.parent = 'General';
    this.inputencoding.templateVariable = 'inputencoding';
    this.inputencoding.preprocessor = function(event){};
    this.inputencoding.processor = function(str, reVar, pluginObj, inputObj){
      var retStr = str.replace(reVar, pluginObj.qcharset);
      if (inputObj) inputObj.isEditable = false; //this isn't editable
      return retStr;
    };
    this.inputencoding.init();
    //outputEncoding parameter    
    this.outputencoding = new cqrCoUnitProto();
    this.outputencoding.id = 'outputencoding';
    this.outputencoding.parent = 'General';
    this.outputencoding.templateVariable = 'outputencoding';
    this.outputencoding.preprocessor = function(event){};
    this.outputencoding.processor = function(str, reVar, pluginObj, inputObj){
      var retStr = str.replace(reVar, pluginObj.rcharset);
      if (inputObj) inputObj.isEditable = false; //this isn't editable
      return retStr;
    };
    this.outputencoding.init();
    //Eof patch
}

var cqrCustomCoUnitsHolder = function(){
    //not implemented

    // hacked co-unit for stripping unknown patterns
    this.strip_unknown = new cqrCoUnitProto();
    this.strip_unknown.id = 'strip_unknown';
    this.strip_unknown.parent = 'Custom';
    this.strip_unknown.process = function Processor(sourceString, outPlugObj, inputObject){
        try{
            this.tuneupRequired = false;
            this.templateVarPattern.lastIndex = 0;
            if (!this.templateVarPattern.test(sourceString)) return sourceString;
            this.templateVarPattern.lastIndex = 0;
            //if (inputObject) inputObject.isEditable = true;
            
            var ret = this.processor(sourceString,  this.templateVarPattern, outPlugObj, inputObject);
            this.templateVarPattern.lastIndex = 0;
            return ret;
        }catch(err){
            cqrLog.err('Critical error in ' + this.id + ' wrapper!', err);
            return sourceString;
        }
    };
    this.strip_unknown.processor = function(str, reVar, pluginObj, inputObj){
        var retStr = str.replace(reVar, '');
        //if (inputObj) inputObj.isEditable = false;
        return retStr;
    };
    this.strip_unknown.init = function(){
        this.templateVarPattern = new RegExp("((\\[:)|{)\\w+(:)*?([\\d\\w]*)*?[\\]}]", "ig");
        cqrLog.debug('"'+this.parent+':'+this.id+'" context unit plugged in.');
    };
    this.strip_unknown.init();
}


var cqrCoUnits = {
    tuneupRequired: false,
    general: new cqrGeneralCoUnitsHolder(),
    custom: new cqrCustomCoUnitsHolder(),
    
    init: function CoUnits(){
        cqrLog.debug('Context units factory initialized.');
    },

    test_all: function(str){
        var ret_val = false;
        for (var co_unit in this.general) {
            if (this.general[co_unit].test(str)) retval = true;
        }
        for (co_unit in this.custom) {
            if (this.custom[co_unit].test(str)) retval = true;
        }
        return ret_val;
    },

    preprocess_all: function(event){
        for (var co_unit in this.general) {
            this.general[co_unit].preprocess(event);
        }
        for (co_unit in this.custom) {
            this.custom[co_unit].preprocess(event);
        }
    },

    process_all: function(strInputValue, queryObject, inputObject){
        this.tuneupRequired = false;
        var ret_str = strInputValue;
        for (var co_unit in this.general) {
            ret_str = this.general[co_unit].process(ret_str, queryObject, inputObject);
            if (this.general[co_unit].tuneupRequired) this.tuneupRequired = true;
        }
        for (co_unit in this.custom) {
            ret_str = this.custom[co_unit].process(ret_str, queryObject, inputObject);
            if (this.custom[co_unit].tuneupRequired) this.tuneupRequired = true;
        }
        return ret_str;
    }
}

cqrCoUnits.init();
