var cqrMenu = {
      doc: Components.classes["@mozilla.org/xul/xul-document;1"].
          createInstance(Components.interfaces.nsIDOMDocument),
    cpAlreadyShowedInMain: [],

    fill: function cqrMenu_Fill_Menu(entriesArr, start_index, limit, containerObj, insertBeforeObj, skipContext){
        //XXX too complex!!
        var entriesCount = 0;
        var i = 0;
        for (var entry in entriesArr) {
            var item = entriesArr[entry];
            if ((!item.ShowInMenu) && (!item.showif)) continue;
            if ((!item.ShowInMenu) && (item.showif) && (skipContext)) continue;
            
            if (limit > 0 && i >= limit) {
                // patch for main FF context menu
                if ((item.showif) && (!item.ShowInMenu) && (cqrEnv.ShowCSPInMainMenu)){
                    //will not break subroutine. We need 
                    //all of the context plugins that is hidden
                    //to get a chance to show up, if the option
                    //"Show context plugins in main menu" is
                    //turned on.
                } else {
                    //not a hidden context plugin. Retrying
                    continue;
                }
            }
            if (start_index && i < start_index){
                i+=1;
                continue;
            }
            if (item.isDir){
                var mItem = cqrMenu.createFolder(item, "queryFolder");
                i+=1;
            }else if ((!item.isDir) && (!item.showif)) {
                mItem = cqrMenu.createItem(item, "queryItem");
                i+=1;
            } else if ((!item.isDir) && (item.showif)) {
                //This is context plugin
                if (item.ShowInMenu) {
                    //... and not hidden - processing as usual
                    //but with eval context
                    if (evalContext(item)) {
                        //got matches
                        mItem = cqrMenu.createItem(item, "contextMatched");
                    } else {
                        mItem = cqrMenu.createItem(item, "contextUnmatched");
                    }
                    i+=1;
                } else {
                    //... and hidden - will show up only if has matches in content
                    if (evalContext(item)) {
                        //got match
                        mItem = cqrMenu.createItem(item, "contextMatched");
                        //will not increment i to not affect the limit
                    } else {
                        //No matches. Not this time.
                        continue;
                    }
                }
            }
            
            if (insertBeforeObj){
                containerObj.insertBefore(mItem, insertBeforeObj);
                entriesCount += 1;
            } else {
                containerObj.appendChild(mItem);
                entriesCount += 1;
            }
        }
        return entriesCount;
    },
    
    fillWithHiddenContextOnly: function cqrMenu_Fill_Menu(entriesArr, containerObj, insertBeforeObj){
        var entriesCount = 0;
        for (var entry in entriesArr) {
            var item = entriesArr[entry];
            if (item.ShowInMenu) continue;
            if (!item.showif) continue;
            
            if ((!item.isDir) && (item.showif)) {
                //... and hidden - will show up only if has matches in content
                if (evalContext(item)) {
                    //got match
                    var mItem = cqrMenu.createItem(item, "contextMatched");
                    //will not increment i to not affect the limit
                } else {
                    //No matches. Not this time.
                    continue;
                }
            }
            if (insertBeforeObj){
                containerObj.insertBefore(mItem, insertBeforeObj);
                entriesCount += 1;
            } else {
                containerObj.appendChild(mItem);
                entriesCount += 1;
            }
        }
        return entriesCount;
    },

    createFolder: function (sp, flag){
      
        //var new_doc = Components.classes["@mozilla.org/xul/xul-document;1"].
        //              createInstance(Components.interfaces.nsIDOMDocument);
        //var new_doc = window.document;
        //if ((cqrMenu.menuPopupRegistry[sp.id])) {
        //    mn = cqrMenu.menuPopupRegistry[sp.id].menu;
        //    pp = cqrMenu.menuPopupRegistry[sp.id].popup;
        //    cqrLog.warn('Cleaning ' + mn.hidden)
        //    while (pp.hasChildNodes()) pp.removeChild(pp.lastChild);
        //    while (mn.hasChildNodes()) mn.removeChild(mn.lastChild);
        //    delete mn;
        //}
        var new_doc = window.document;
        var lostPp = new_doc.getElementById(sp.id+'-menu');
        var lostMn = new_doc.getElementById(sp.id);
        //cqrLog.warn('Cleaning ' + lostPp);
        //cqrLog.warn('Cleaning ' + lostMn);
        if (lostPp) while (lostPp.hasChildNodes()) lostPp.removeChild(lostPp.lastChild);
        if (lostMn) while (lostMn.hasChildNodes()) lostMn.removeChild(lostMn.lastChild);
        delete lostPp;
        delete lostMn;
        
        
        var retItem = new_doc.createElement("menu");
        retItem.setAttribute("id", sp.id+'-menu');
        retItem.setAttribute("label", sp.Title);
        retItem.setAttribute("conquery_flag", flag);
        retItem.setAttribute("class", 'menu-iconic');
        retItem.setAttribute('onclick', 'return false;');
        //Shadow912: patch for multi search site query,
        //  suggested/base idea by Aleksey Kosterin.
        //retItem.setAttribute('ondblclick', 'if (event.target != this) return; this.parentNode.hidePopup(); cqrMultiQuery("'+sp.id+'", event.ctrlKey);');
        retItem.setAttribute('ondblclick', 'if (event.target != this) return; recursiveHidePopup(this); cqrMultiQuery("'+sp.id+'", event.ctrlKey);');
        //Eof patch

        var popup = new_doc.createElement("menupopup");
        retItem.appendChild(popup);
        popup = retItem.firstChild;
        popup.id = sp.id;
        popup.setAttribute('cqrFilePath', sp.filepath);
        popup.setAttribute('onpopupshowing', 'FillMenu3(event.ctrlKey, "'+sp.id+'", event)');
        popup.setAttribute('onclick', 'return false;');
        //popup.setAttribute('onpopuphiding', 'cqrMenu.hiding("'+sp.id+'")');
        
        //cqrMenu.menuPopupRegistry[sp.id] = {'shown':true, 'menu':retItem, 'popup':popup};
        return retItem;
    },

    createItem: function(entry, flag){
        //doc = cqrMenu.doc;
        var doc = window.document;
        var lostMi = doc.getElementById(entry.id);
        if (lostMi){
            cqrLog.warn('Gotcha!!')
        }
        
        var retItem = doc.createElement("menuitem");
        retItem.setAttribute("id", entry.id);
        retItem.setAttribute("class", "menuitem-iconic");//"menuitem-iconic");
        if (entry.raw_icon) {
            retItem.setAttribute("image", entry.raw_icon);
        } else {
            retItem.setAttribute("image", entry.iconpath);
        }

        //if ((!entry.iconpath) && (!entry.showif)){
        //    if (cqrEnv.HTTPIcon){
        //        icourl = url2host(entry.Action);
        //        if (icourl) {
        //            retItem.setAttribute("image", icourl + "/favicon.ico");
        //            //retItem.setAttribute("image", "chrome://conquery/skin/no-icon.png")
        //        };
        //    }
        //}else{
        //    retItem.setAttribute("image", entry.iconpath);
        //}
        retItem.setAttribute("label", entry.Title);
        retItem.setAttribute("tooltiptext", cqrMess.GetStringFromName('cqr.menu.plgToolTip'));
        retItem.setAttribute("oncommand", "ProcessEntry(event.ctrlKey, '"+entry.id+"')");
        retItem.setAttribute("conquery_flag", flag);
        retItem.setAttribute("cqrFilePath", flag);
        return retItem;
    },

    cleanupMenu: function(MenuId){
        var mToClean = window.document.getElementById(MenuId);
        if (!mToClean) return;
        var entriesTrash = [];
        for (var i=0; i < mToClean.childNodes.length; i++){
            if ((mToClean) && (mToClean.childNodes[i].getAttribute("conquery_flag")!="")){
                entriesTrash.push(mToClean.childNodes[i]);
            }
        }
        for (var each in entriesTrash) {
            if (mToClean) mToClean.removeChild(entriesTrash[each]);
        }
    }
    
    //hiding: function(ppId){
    //    if (cqrMenu.menuPopupRegistry[ppId]) cqrMenu.menuPopupRegistry[ppId].shown = false;
    //}

}



 /////// END classes ////////
////////////////////////////


 ////////////////////////////
//////// Globals ///////////

//Active Entries holder
//var cqrFileFactory = new _cqrFileHash(); //File factory
var cqrFItem = new cqrItemClass(); //File item
//Shadow912: patch for McAfee SiteAdvisor & google issue
//report: nameless one / fix: tks(tksmashiw)
//thx for your job, http://d.hatena.ne.jp/tksmashiw/20080601#p1
//                  http://d.hatena.ne.jp/tksmashiw/20080603#p1
//comment outed following line
//var cqrFileObj = cqrItemClass();
//Eof patch
//var cqrFileHash = new _cqrFileHash();
var QueryHash = new Object();
var cqrShowAlternatives = false;
var cqrcancel = false;
//Shadow912: patch for query strings of URI, RFC 3986
var QueryTermsName = ""; //Strings of name attribute in form: {searchTerms}
//EOf patch
//Shadow912: patch for PATH_INFO format URL & strings of URI, RFC 3986
var PathArray = new Object();
var QueryPathIndex = null; //Index of {searchTerms} in PATH_INFO format URL
//Eof patch

//Shadow912: patch for Thunderbird 3(Shredder)
//if (navigator.userAgent.search(/Thunderbird/gi) != -1){
if (navigator.userAgent.search(/Thunderbird/gi) != -1 ||
    navigator.userAgent.search(/Shredder/gi) != -1){
//Eof patch
    var cqrMailFlag = true;
} else {
    var cqrMailFlag = false;
}

var cqrMess = srGetStrBundle("chrome://conquery/locale/conquery.properties");

/// Prefs globals ///
var cqrNavigatorDefaultCharset = "";
var cqrHideQueryTo = false;

function cqrAbsURI(base, url) 
{
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                .getService(Components.interfaces.nsIIOService);
  var baseURI  = ioService.newURI(base, null, null);
  return ioService.newURI(baseURI.resolve(url), null, null).spec;
}

function cqrGetClipboardText(){
// many thanks to XUL planet! :)
// http://xulplanet.com/tutorials/xultu/clipboard.html
try{
    var clip = Components.classes["@mozilla.org/widget/clipboard;1"].
        getService(Components.interfaces.nsIClipboard);
    if (!clip) return false;

    var trans = Components.classes["@mozilla.org/widget/transferable;1"].
        createInstance(Components.interfaces.nsITransferable);
    if (!trans) return false;
    trans.addDataFlavor("text/unicode");
    clip.getData(trans,clip.kGlobalClipboard);
    var str = new Object();
    var strLength = new Object();

    trans.getTransferData("text/unicode",str,strLength);
    if (str) str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
    if (str) var pastetext = str.data.substring(0,strLength.value / 2);
    if (pastetext) return pastetext;
    else return false;
}catch(er){return false;}
}


function cqrGetBrowserForWindow(win) {  
    var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].
        getService(Components.interfaces.nsIWindowMediator);
    var enumerator = windowManager.getEnumerator(null);
    while (enumerator.hasMoreElements()) {
        var newBrowser = enumerator.getNext().getBrowser();
        var newWin = newBrowser.contentWindow;
        var cntTabs = newBrowser.mTabContainer.childNodes.length;
        for (var i=0;i<cntTabs;i++){
            var nextTab = newBrowser.mTabContainer.childNodes[i];
            var newTabBr = newBrowser.getBrowserForTab(nextTab);
            if (newTabBr.contentWindow == win) return newTabBr; 
        }
    }
    return null;
}

function getFNameFromURI(uri){
    var arr = uri.split("/");
    return arr[arr.length - 1];
    }

function url2host(url){
    var re = new RegExp("^http://([^/]*)","ig");
    var retmp = re.exec(url);
    if (retmp) {
        return retmp[0];
    } else {
        return "";
    }
}


//Shadow912: patch
//does not use "Force in SidePanel", comment outed
////// Borrowed from browser.js /////

//var gWebPanelURI;
//function openWebPanel(aTitle, aURI)
//{
    // Ensure that the web panels sidebar is open.
//    var tst = toggleSidebar('viewWebPanelsSidebar', true);
//    if (!tst) return false;

    // Set the title of the panel.
//    document.getElementById("sidebar-title").value = aTitle;

    // Tell the Web Panels sidebar to load the bookmark.
//    var sidebar = document.getElementById("sidebar");
//    if (sidebar.docShell && sidebar.contentDocument && sidebar.contentDocument.getElementById('web-panels-browser')) {
//        sidebar.contentWindow.loadWebPanel(aURI);
//        if (gWebPanelURI) {
//            gWebPanelURI = "";
//            sidebar.removeEventListener("load", asyncOpenWebPanel, true);
//        }
//    }
//    else {
        // The panel is still being constructed.  Attach an onload handler.
//        if (!gWebPanelURI)
//            sidebar.addEventListener("load", asyncOpenWebPanel, true);
//        gWebPanelURI = aURI;
//    }
//    return true;
//}



// |forceOpen| is a bool that indicates that the sidebar should be forced open.  In other words
// the toggle won't be allowed to close the sidebar.
//function toggleSidebar(aCommandID, forceOpen) {
//  var sidebarBox = document.getElementById("sidebar-box");
//  if (!aCommandID)
//    aCommandID = sidebarBox.getAttribute("sidebarcommand");

//  var elt = document.getElementById(aCommandID);
//  if (!elt) return false;   //This is Mozilla Suite or NS7 with very complex sidebars. Giving up...
//  var sidebar = document.getElementById("sidebar");
//  var sidebarTitle = document.getElementById("sidebar-title");
//  var sidebarSplitter = document.getElementById("sidebar-splitter");

//  if (!forceOpen && elt.getAttribute("checked") == "true") {
//    elt.removeAttribute("checked");
//    sidebarBox.setAttribute("sidebarcommand", "");
//    sidebarTitle.setAttribute("value", "");
//    sidebarBox.hidden = true;
//    sidebarSplitter.hidden = true;
//    content.focus();
//    return true;
//  }

//  var elts = document.getElementsByAttribute("group", "sidebar");
//  for (var i = 0; i < elts.length; ++i)
//    elts[i].removeAttribute("checked");

//  elt.setAttribute("checked", "true");;

//  if (sidebarBox.hidden) {
//    sidebarBox.hidden = false;
//    sidebarSplitter.hidden = false;
//  }

//  var url = elt.getAttribute("sidebarurl");
//  var title = elt.getAttribute("sidebartitle");
//  if (!title)
//    title = elt.getAttribute("label");
//  sidebar.setAttribute("src", url);
//  sidebarBox.setAttribute("src", url);
//  sidebarBox.setAttribute("sidebarcommand", elt.id);
//  sidebarTitle.setAttribute("value", title);
//  if (aCommandID != "viewWebPanelsSidebar") { // no searchbox there
    // if the sidebar we want is already constructed, focus the searchbox
//    if ((aCommandID == "viewBookmarksSidebar" && sidebar.contentDocument.getElementById("bookmarksPanel"))
//    || (aCommandID == "viewHistorySidebar" && sidebar.contentDocument.getElementById("history-panel")))
//      sidebar.contentDocument.getElementById("search-box").focus();
    // otherwiese, attach an onload handler
//    else
//      sidebar.addEventListener("load", asyncFocusSearchBox, true);
//  }
//  return true;
//}
//Eof patch
